searchNodes=[{"doc":"SegmentSpec is a simple data model to represent the events defined in the Segment.com spec . The parse/1 and parse!/1 functions convert a Segment event in its JSON-decoded format into an appropriate struct. This struct is of type event_struct/0 , and contains all fields particular to the event type, as well as all fields common to all Segment events. The common field context is parsed into a SegmentSpec.Common.Context struct during this process. Each field that is part of a struct is represented as a snake_case atom, regardless of whether the input field was snake_case or camelCase. Each field that is not part of a struct, such as the contents of the properties or traits , is represented as a string, exactly as it was received. In other words, we normalize the internal fields that Segment puts in the events, but we do not touch the fields that the Segment user provides. The normalize/2 and normalize!/2 functions return a normalized version of the given Segment event, with or without null fields. Internal Segment fields are coerced into snake_case as described above. iex&gt; track = %{ ...&gt; &quot;type&quot; =&gt; &quot;track&quot; , ...&gt; &quot;userId&quot; =&gt; &quot;xyz&quot; , ...&gt; &quot;event&quot; =&gt; &quot;Clicked thing&quot; , ...&gt; &quot;properties&quot; =&gt; %{ &quot;thingColor&quot; =&gt; &quot;red&quot; } , ...&gt; &quot;context&quot; =&gt; %{ &quot;groupId&quot; =&gt; &quot;abc&quot; } ...&gt; } iex&gt; SegmentSpec . parse! ( track ) % SegmentSpec.Track { type : &quot;track&quot; , user_id : &quot;xyz&quot; , event : &quot;Clicked thing&quot; , properties : %{ &quot;thingColor&quot; =&gt; &quot;red&quot; } , context : % SegmentSpec.Common.Context { group_id : &quot;abc&quot; } } iex&gt; SegmentSpec . normalize! ( track ) %{ &quot;type&quot; =&gt; &quot;track&quot; , &quot;user_id&quot; =&gt; &quot;xyz&quot; , &quot;event&quot; =&gt; &quot;Clicked thing&quot; , &quot;properties&quot; =&gt; %{ &quot;thingColor&quot; =&gt; &quot;red&quot; } , &quot;context&quot; =&gt; %{ &quot;group_id&quot; =&gt; &quot;abc&quot; } }","ref":"SegmentSpec.html","title":"SegmentSpec","type":"module"},{"doc":"Returns a normalized version of the given Segment event, in which Segment's internal fields have been coerced into snake_case. Pass the include_nil: true option to include empty fields.","ref":"SegmentSpec.html#normalize/2","title":"SegmentSpec.normalize/2","type":"function"},{"doc":"Returns a normalized version of the given Segment event, in which Segment's internal fields have been coerced into snake_case. Pass the include_nil: true option to include empty fields.","ref":"SegmentSpec.html#normalize!/2","title":"SegmentSpec.normalize!/2","type":"function"},{"doc":"Parses a Segment event map into the appropriate event_struct/0 struct.","ref":"SegmentSpec.html#parse/1","title":"SegmentSpec.parse/1","type":"function"},{"doc":"Parses a Segment event map into the appropriate event_struct/0 struct.","ref":"SegmentSpec.html#parse!/1","title":"SegmentSpec.parse!/1","type":"function"},{"doc":"","ref":"SegmentSpec.html#t:event_map/0","title":"SegmentSpec.event_map/0","type":"type"},{"doc":"","ref":"SegmentSpec.html#t:event_struct/0","title":"SegmentSpec.event_struct/0","type":"type"},{"doc":"Represents a Segment alias event.","ref":"SegmentSpec.Alias.html","title":"SegmentSpec.Alias","type":"module"},{"doc":"","ref":"SegmentSpec.Alias.html#new/2","title":"SegmentSpec.Alias.new/2","type":"function"},{"doc":"Parses a Segment alias event into a SegmentSpec.Alias struct.","ref":"SegmentSpec.Alias.html#parse!/1","title":"SegmentSpec.Alias.parse!/1","type":"function"},{"doc":"","ref":"SegmentSpec.Alias.html#t:t/0","title":"SegmentSpec.Alias.t/0","type":"type"},{"doc":"Represents the context field common to Segment events.","ref":"SegmentSpec.Common.Context.html","title":"SegmentSpec.Common.Context","type":"module"},{"doc":"","ref":"SegmentSpec.Common.Context.html#new/2","title":"SegmentSpec.Common.Context.new/2","type":"function"},{"doc":"","ref":"SegmentSpec.Common.Context.html#t:t/0","title":"SegmentSpec.Common.Context.t/0","type":"type"},{"doc":"Represents a Segment group event.","ref":"SegmentSpec.Group.html","title":"SegmentSpec.Group","type":"module"},{"doc":"","ref":"SegmentSpec.Group.html#new/2","title":"SegmentSpec.Group.new/2","type":"function"},{"doc":"Parses a Segment group event into a SegmentSpec.Group struct.","ref":"SegmentSpec.Group.html#parse!/1","title":"SegmentSpec.Group.parse!/1","type":"function"},{"doc":"","ref":"SegmentSpec.Group.html#t:t/0","title":"SegmentSpec.Group.t/0","type":"type"},{"doc":"Represents a Segment identify event.","ref":"SegmentSpec.Identify.html","title":"SegmentSpec.Identify","type":"module"},{"doc":"","ref":"SegmentSpec.Identify.html#new/2","title":"SegmentSpec.Identify.new/2","type":"function"},{"doc":"Parses a Segment identify event into a SegmentSpec.Identify struct.","ref":"SegmentSpec.Identify.html#parse!/1","title":"SegmentSpec.Identify.parse!/1","type":"function"},{"doc":"","ref":"SegmentSpec.Identify.html#t:t/0","title":"SegmentSpec.Identify.t/0","type":"type"},{"doc":"Represents a Segment page event.","ref":"SegmentSpec.Page.html","title":"SegmentSpec.Page","type":"module"},{"doc":"","ref":"SegmentSpec.Page.html#new/2","title":"SegmentSpec.Page.new/2","type":"function"},{"doc":"Parses a Segment page event into a SegmentSpec.Page struct.","ref":"SegmentSpec.Page.html#parse!/1","title":"SegmentSpec.Page.parse!/1","type":"function"},{"doc":"","ref":"SegmentSpec.Page.html#t:t/0","title":"SegmentSpec.Page.t/0","type":"type"},{"doc":"Represents a Segment screen event.","ref":"SegmentSpec.Screen.html","title":"SegmentSpec.Screen","type":"module"},{"doc":"","ref":"SegmentSpec.Screen.html#new/2","title":"SegmentSpec.Screen.new/2","type":"function"},{"doc":"Parses a Segment screen event into a SegmentSpec.Screen struct.","ref":"SegmentSpec.Screen.html#parse!/1","title":"SegmentSpec.Screen.parse!/1","type":"function"},{"doc":"","ref":"SegmentSpec.Screen.html#t:t/0","title":"SegmentSpec.Screen.t/0","type":"type"},{"doc":"Represents a Segment track event.","ref":"SegmentSpec.Track.html","title":"SegmentSpec.Track","type":"module"},{"doc":"","ref":"SegmentSpec.Track.html#new/2","title":"SegmentSpec.Track.new/2","type":"function"},{"doc":"Parses a Segment track event into a SegmentSpec.Track struct.","ref":"SegmentSpec.Track.html#parse!/1","title":"SegmentSpec.Track.parse!/1","type":"function"},{"doc":"","ref":"SegmentSpec.Track.html#t:t/0","title":"SegmentSpec.Track.t/0","type":"type"}]